<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>SNOPT Test</title>
    <authors>
      <author>Fabian Wein</author>
    </authors>
    <date>2015-01-14</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>Fabian Wein, thesis</references>
    <isVerified>yes</isVerified>
    <description>Standard compliance minimization with uses SNOPT (Sparse nonlinear optimizer).
                 SNOPT is commercial code, the chair applied mathematics 2 (FAU) has a license which includes the source.
                 To use the code you need the encrypted file snopt-7.2.8-cfsdeps.zip in your cfsdepschace source and
                 the key in the cmake variable CFS_KEY_SNOPT.</description>
  </documentation>

  <fileFormats>
    <output>
      <hdf5 />
      <info />
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> <comp dof="y"/> 
           </fix>
           <force name="right_lower">
            <comp dof="y" value="-1"/>
          </force>
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>          
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>             
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solverList>
          <directLDL/>
        </solverList>
      </system>
    </linearSystems>
  </sequenceStep>
  
  <optimization>
    <costFunction type="compliance" task="minimize" > 
      <stopping queue="999" value="0.002" type="designChange"/>
    </costFunction>
    
    <constraint type="volume" bound="upperBound" value="0.5" />
    
    <optimizer type="snopt"  maxIterations="10">
      <snopt>
        <!-- verify_level=3 triggers finite difference check. See .snopt file -->
        <option name="verify_level" type="integer" value="0"/>
        <option name="major_feasibility_tolerance" type="real" value="1e-6"/>
        <option name="major_optimality_tolerance" type="real" value="1e-6"/>
      </snopt>
    </optimizer>
      
    <ersatzMaterial region="mech" material="mechanic" method="simp">
      <filters>
        <filter neighborhood="maxEdge" value="1.5" type="density"/> 
      </filters>
      
     <design name="density" initial="0.5" lower="1e-3" upper="1.0" />
      
     <transferFunction type="simp" application="mech" param="3" /> 
     <export write="iteration" save="all"/>
      
    </ersatzMaterial>
    <commit mode="forward" stride="1"/>
  </optimization>
  
</cfsSimulation>


